
var _ = require("underscore");

function Info () {
	this.options = {};

	this.set('defaults', {
		record_status: "n",
		type_of_record: "a",
		bibliographic_level: " ",
		type_of_control: " ",
		character_coding_scheme: " ",
		indicator_count: 2,
		subfield_code_count: 2,
		encoding_level: " ",
		descriptive_cataloging_form: " ",
		multipart_resource_record_level: " ",
		length_of_length_field: 4,
		length_of_starting_char_position: 5,
		length_of_implementation_defined_portion: 0
	});
}

Info.prototype.set =
Info.prototype.get = function (key, value) {
  if (arguments.length == 1)
    return this.options[key];
  this.options[key] = value;
  return this;
};

Info.prototype.record_status = function() {
	if (arguments.length == 0) {
		
		if(_.isUndefined(this.get('record_status'))) {
			return this.get('defaults').record_status;	
		}

		return this.get('record_status');
	}

	this.set('record_status', arguments[0]);
	return this;
};

Info.prototype.type_of_record = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('type_of_record'))) {
			return this.get('defaults').type_of_record;
		}

		return this.get('type_of_record');
	}

	this.set('type_of_record', arguments[0]);
	return this;
};

Info.prototype.bibliographic_level = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('bibliographic_level'))) {
			return this.get('defaults').bibliographic_level;
		}

		return this.get('bibliographic_level');
	}

	this.set('bibliographic_level', arguments[0]);
	return this;
};

Info.prototype.type_of_control = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('type_of_control'))) {
			return this.get('defaults').type_of_control;
		}

		return this.get('type_of_control');
	}

	this.set('type_of_control', arguments[0]);
	return this;
};

Info.prototype.character_coding_scheme = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('character_coding_scheme'))) {
			return this.get('defaults').character_coding_scheme;
		}

		return this.get('character_coding_scheme');
	}

	this.set('character_coding_scheme', arguments[0]);
	return this;
};

Info.prototype.indicator_count = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('indicator_count'))) {
			return this.get('defaults').indicator_count;
		}

		return this.get('indicator_count');
	}

	this.set('indicator_count', arguments[0]);
	return this;
};

Info.prototype.subfield_code_count = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('subfield_code_count'))) {
			return this.get('defaults').subfield_code_count;
		}

		return this.get('subfield_code_count');
	}

	this.set('subfield_code_count', arguments[0]);
	return this;
};

Info.prototype.encoding_level = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('encoding_level'))) {
			return this.get('defaults').encoding_level;
		}

		return this.get('encoding_level');
	}

	this.set('encoding_level', arguments[0]);
	return this;
};

Info.prototype.descriptive_cataloging_form = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('descriptive_cataloging_form'))) {
			return this.get('defaults').descriptive_cataloging_form;
		}

		return this.get('descriptive_cataloging_form');
	}

	this.set('descriptive_cataloging_form', arguments[0]);
	return this;
};

Info.prototype.multipart_resource_record_level = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('multipart_resource_record_level'))) {
			return this.get('defaults').multipart_resource_record_level;
		}

		return this.get('multipart_resource_record_level');
	}

	this.set('multipart_resource_record_level', arguments[0]);
	return this;
};

Info.prototype.length_of_length_field = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('length_of_length_field'))) {
			return this.get('defaults').length_of_length_field;
		}

		return this.get('length_of_length_field');
	}

	this.set('length_of_length_field', arguments[0]);
	return this;
};

Info.prototype.length_of_starting_char_position = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('length_of_starting_char_position'))) {
			return this.get('defaults').length_of_starting_char_position;
		}

		return this.get('length_of_starting_char_position');
	}

	this.set('length_of_starting_char_position', arguments[0]);
	return this;
};

Info.prototype.length_of_implementation_defined_portion = function() {
	if (arguments.length == 0) {

		if(_.isUndefined(this.get('length_of_implementation_defined_portion'))) {
			return this.get('defaults').length_of_implementation_defined_portion;
		}

		return this.get('length_of_implementation_defined_portion');
	}

	this.set('length_of_implementation_defined_portion', arguments[0]);
	return this;
};

module.exports = exports = Info;