
var _ = require("underscore")
	pad = require('pad');

function Leader () {
	this.options = {};
	this.set('recordLength', 0);
	this.set('baseAddress', 0);
	this.set('catalog', null);
};

Leader.prototype.set =
Leader.prototype.get = function (key, value) {
  if (arguments.length == 1)
    return this.options[key];
  this.options[key] = value;
  return this;
};

Leader.prototype.recordLength = function(recordLength) {
	if (arguments.length == 0) {
		return this.get('recordLength');
	}

	this.set('recordLength', arguments[0]);
	return this;
};

Leader.prototype.baseAddress = function(baseAddress) {
	if (arguments.length == 0) {
		return this.get('baseAddress');
	}

	this.set('baseAddress', arguments[0]);
	return this;
};

Leader.prototype.recordinfo = function(recordinfo) {
	if(arguments.length == 0) {
		return this.get('recordinfo');
	}

	this.set('recordinfo', recordinfo);
	return this;
};

Leader.prototype.create = function() {
	
	var leader = "";
	
	leader += pad(5, this.recordLength().toString() , '0');
	leader += this.recordinfo().record_status();
	leader += this.recordinfo().type_of_record();
	leader += this.recordinfo().bibliographic_level()
	leader += this.recordinfo().type_of_control();
	leader += this.recordinfo().character_coding_scheme();
	leader += this.recordinfo().indicator_count().toString();
	leader += this.recordinfo().subfield_code_count().toString();
	leader += pad(5, this.baseAddress().toString() , '0');
	leader += this.recordinfo().encoding_level();
	leader += this.recordinfo().descriptive_cataloging_form();
	leader += this.recordinfo().multipart_resource_record_level();
	leader += this.recordinfo().length_of_length_field().toString();
	leader += this.recordinfo().length_of_starting_char_position().toString();
	leader += this.recordinfo().length_of_implementation_defined_portion().toString();
	leader += "0";

	return leader;
};

module.exports = exports = Leader;