var fs = require('fs')
	, _ = require("underscore")
	, Field = require('./field')
	, SubField = require('./subfield')
	, Marc = require('./record');

function Writer () {
	if(! _.isUndefined(arguments[0])) {
		this.options = arguments[0];		
	}else {
		this.options = {};
	}
};

Writer.prototype.set =
Writer.prototype.get = function (key, value) {
  if (arguments.length == 1)
    return this.options[key];
  this.options[key] = value;
  return this;
};

Writer.prototype.sources = function() {
	if (arguments.length == 0) {
		return this.get('sources');
	}

	if(! _.isArray(arguments[0])) {
		arguments[0] = [arguments[0]];
	}

	this.set('sources', arguments[0]);
	return this;
}

Writer.prototype.file = function() {
	if (arguments.length == 0) {
		return this.get('file');
	}

	this.set('file', arguments[0]);
	return this;
}

Writer.prototype.saveAsMarc = function() {
	
	var file = this.file();

	_.each(this.sources(), function(source) {
		fs.writeFileSync(file, source.toMarc(), 'utf8');
	});

	this.set('sources', new Array());
}

module.exports = exports = Writer;